#!/bin/bash

set -e

# Exit immediately for unbound variables.
set -u


length=$#
device=""
io=""
characteristic=""
option=""
ATV_id="192.168.1.34"
airplay_credentials="5b25cb1f81113aad58cae4eba40051d6d10928ae0f59fe88dbf8b53750abe675:4843b4387976af4f25068a7eb7fb4ef71cb40ecb44bca96d060e174057cc4acc:33394246433942322d383333322d343435312d414242452d314230344138373146354338:30626137626665652d633832382d343334342d396531642d373036326434393838316236"

if [ $length -le 1 ]; then
   printf "Usage: $0 Get < AccessoryName > < Characteristic >\n"
   printf "Usage: $0 Set < AccessoryName > < Characteristic > < Value >\n"
   exit -1
fi

# printf "args =$#\n"   # debug
# printf "arg1 =$1\n"   # debug

if [ $length -ge 1 ]; then
    io=$1
   #  printf "io=$io\n"   # debug
fi
if [ $length -ge 2 ]; then
    device=$2
   #  printf "device = ${device}\n"   # debug
fi
if [ $length -ge 3 ]; then
    characteristic=$3
   #  printf "Characteristic = ${characteristic}\n"   # debug
fi
if [ $length -ge 4 ]; then
    option=$4
   #  printf "option = ${option}\n"   # debug
fi

if [ "${io}" == "Get" ]; then
   case $characteristic in
      'On')
         # Get Apple TV power state
         ATV_POWER_STATE=$(sudo -u pi /home/pi/.local/bin/atvremote -s ${ATV_id} --airplay-credentials ${airplay_credentials} power_state)
         if [ "${ATV_POWER_STATE}" = "PowerState.On" ]
         then
            printf "1\n"
         else
            printf "0\n"
         fi
         exit 0
         ;;
      *)
         printf "UnHandled Get ${device}  Characteristic ${characteristic}\n"
         exit -1
         ;;
    esac
fi
if [ "${io}" == 'Set' ]; then
   case $characteristic in
      'On')
         # Get Apple TV current power state and switch accordingly
         ATV_POWER_STATE=$(sudo -u pi /home/pi/.local/bin/atvremote -s ${ATV_id} --airplay-credentials ${airplay_credentials} power_state)
         if [ "${ATV_POWER_STATE}" = "PowerState.On" ]
         then
            sudo -u pi /home/pi/.local/bin/atvremote -s ${ATV_id} --airplay-credentials ${airplay_credentials} turn_off
         else
            sudo -u pi /home/pi/.local/bin/atvremote -s ${ATV_id} --airplay-credentials ${airplay_credentials} turn_on
         fi
         exit 0
         ;;
      *)
         printf "UnHandled Set ${device} Characteristic ${characteristic}"
         exit -1
         ;;
    esac
fi
printf "Unknown io command ${io}\n"
exit -1
